package hpdos.handler;

import hpdos.grpc.*;
import hpdos.message.*;
import io.grpc.stub.StreamObserver;
import java.util.ArrayList;

public class NetworkHandler extends NetworkServiceGrpc.NetworkServiceImplBase {
    private IOHandler ioHandler;
    public NetworkHandler(IOHandler ioHandler) {
        this.ioHandler = ioHandler;
    }

    @Override
    public void readMetadata(Packet request,
                        StreamObserver<Packet> responseObserver) {
        System.out.println("Data received" + request.toString());
        String key = "dummy";
        String value = "dummy";
        ArrayList<Ack> acks = new ArrayList<>();
        acks.add(ResponseBuilder.buildAck(0, 100, key, 0, value));

        ArrayList<Response> responses = new ArrayList<>();
        responses.add(ResponseBuilder.
                buildResponsePacket(MessageConstants.METADATA_READ, acks, null));
        Packet packet = ResponseBuilder.buildPacket(responses);
        System.out.println(packet);
        responseObserver.onNext(packet);
        responseObserver.onCompleted();
    }

    @Override
    public void createMetadata(Packet request, StreamObserver<Packet> responseObserver) {
        super.createMetadata(request, responseObserver);
    }

    @Override
    public void updateMetadata(Packet request, StreamObserver<Packet> responseObserver) {
        super.updateMetadata(request, responseObserver);
    }

    @Override
    public void deleteMetadata(Packet request, StreamObserver<Packet> responseObserver) {
        super.deleteMetadata(request, responseObserver);
    }
}
