package hpdos.lib;

import java.util.HashMap;

public class MemoryStorage implements StorageService{
    private final HashMap<String, StorageModel> memoryKVStore;
    public MemoryStorage() {
        this.memoryKVStore = new HashMap<>();
    }
    @Override
    public boolean create(String key, StorageModel value) {
        try {
            if (memoryKVStore.containsKey(key))
                return false;
            memoryKVStore.put(key, value);
        } catch (Exception e) {
            return false;
        }
        return true;
    }

    @Override
    public StorageModel readByKey(String key) {
        return memoryKVStore.get(key);
    }

    @Override
    public boolean update(String key, StorageModel value) {
        if (!memoryKVStore.containsKey(key))
            return false;
        memoryKVStore.put(key, value);
        return true;
    }

    @Override
    public boolean delete(String key) {
        try {
            memoryKVStore.remove(key);
        } catch (Exception e) {
            return false;
        }
        return true;
    }
}
